-- Remember to backup the "before" state of this database, since we'll be making changes
-- "WITH INIT" is designated, so this WILL overlay the existing backup file (if exists)
BACKUP DATABASE [AdventureWorksDW2012] 
TO  DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\Backup\AdventureWorksDW2012_pre_colstore.bak' 
WITH INIT, COMPRESSION, NAME = N'AdventureWorksDW2012-Full Database Backup';
GO

-- Create a supporting NCL
USE [AdventureWorksDW2012];
GO

ALTER TABLE dbo.FactProductInventory
DROP COLUMN MovementDate;
GO

ALTER TABLE [dbo].[FactProductInventory] DROP CONSTRAINT [PK_FactProductInventory]
GO

ALTER TABLE [dbo].[FactProductInventory] DROP CONSTRAINT [FK_FactProductInventory_DimDate]
GO

ALTER TABLE dbo.FactProductInventory
ADD DateKeyTmp date NULL;
GO

UPDATE dbo.FactProductInventory 
SET DateKeyTmp =
	SUBSTRING(CAST(DateKey as varchar),5,2) + '-' +
		SUBSTRING(CAST(DateKey as varchar),7,2) + '-' +
		SUBSTRING(CAST(DateKey as varchar),1,4);
GO

ALTER TABLE dbo.FactProductInventory
DROP COLUMN DateKey;
GO

EXEC sp_rename 'dbo.FactProductInventory.DateKeyTmp', 'DateKey', 'COLUMN';
GO

ALTER TABLE dbo.FactProductInventory
ALTER COLUMN DateKey date NOT NULL;
GO

CREATE NONCLUSTERED INDEX [NCI_FactProductInventory_DateKey]
ON [dbo].[FactProductInventory] ([DateKey])
INCLUDE ([ProductKey],[UnitCost],[UnitsOut]);
GO

-- check the current record count & szie of the table

select count(*) from dbo.FactProductInventory
GO
sp_spaceused 'FactProductInventory'
GO


-- Grow table significantly (estimated 5 minutes execution time)
USE [AdventureWorksDW2012];
GO

INSERT INTO [dbo].[FactProductInventory]
           ([ProductKey]
           ,[DateKey]
           ,[UnitCost]
           ,[UnitsIn]
           ,[UnitsOut]
           ,[UnitsBalance])
SELECT		[ProductKey]
           ,[DateKey]
           ,[UnitCost]
           ,[UnitsIn]
           ,[UnitsOut]
           ,[UnitsBalance]
FROM [dbo].[FactProductInventory];
GO 3

-- check the current record count & szie of the table

select count(*) from dbo.FactProductInventory
GO
sp_spaceused 'FactProductInventory'
GO